<!DOCTYPE html>
<html>
<head>
	<title>JS function Exo CRC </title>
</head>
<body>

Cyclic Redundancy Check (CRC)

ennoncé : 
la méthode de CRC permet de corriger une simple erreur 
Le but de l'exercice est de créer une fonction qui calcule le CRC d'un message de 8 octets. 
comment on traite le message ?
comment on vérifie que le message ne fait pas plus de 8 octets ? 
comment on découpe le message ?
comment on le transforme en binaire ? 

une fonction avec un argument 
8 charactères de la table ASCII
un mot de 8 lettres.
si moins de 8 charactère on remplit avec des valeurs 0 de la table ASCII

la fonction doit retourner 2 charactère (celui du haut et celui de droite)

si un nombre impair de 1 donc = 1 
sinon 0


<script>

//transformer une lettre en langage binaire

function toBinary (lettre) {

		// on transforme 1 lettre en langage binaire de 8 bits en mettant des 0 à gauche
		binary = ("00000000" + lettre.charCodeAt(0).toString(2)).slice(-8);
	return binary; //"01100010"
}

function toBinary2 (mot) {
	var binary2 = [];
	// le mot possède forcément une longueur de 8.
	while (mot.length < 8 ) {
		mot += String.fromCharCode(0);// on le remplit par du vide
		}
	// On transforme l'ensemble des lettres en binaire
	for (var i = 0; i < mot.length; i++) {
		binary2.push(toBinary(mot[i])); // on push une lettre en "binaire" dans le tableau
	}

	return binary2;
}

// calculer le CRC

// on met en bit une lettre
function toBit (lettre) {
bit = toBinary(lettre); // on le met en binaire
bit = bit.split(""); //bit = ["0","1","1","0","1","0","0","0"]

for (var i = 0; i < bit.length; i++) {
	bit [i] = parseInt(bit[
	*
	i]); // on transforme chaque "bit" en valeur
}
return bit; // bit = [0,1,1,0,1,0,0,0] valeur de la lettre 1

}

//on additionne l'ensemble des bits du 1er caractère
function addBit (lettre) {
	bit = toBit (lettre); //bit = [0,1,1,0,1,0,0,0]
	total = 0;
	for (var i = 0; i < bit.length; i++) {
		total = (total + bit[i])%2;
	}
	return total; // total = 1 ou 0
}


// on met en binaire l'ensemble des caractères du mot
function toBit (mot) {



for (var i = 0; i < mot.length; i++) {
	mot = toBit(mot[i]);
	 // 
}
return mot; // je veux que chaque ligne me donne un résulat

}


</script>

<!-- var date = "15/08/2000";
var jour = date.substring(0,2);
var mois = date.substring(3,5);
var annee = date.substring(6,10);

Résultat
15
08
2000 
ح-->

<!-- /////////////////////// Exemple //////////////////////////////////////

CRC is an error detection mechanism 
Based on binary division

CRC generator
Often represented as algebraic polynomial
The polynomial format is used for 2 reasons
•	Short
•	Can be used to prove the concept mathematically 

The polynomial is represented as a binary pattern

Rule : 
the power of each term shows the position of the bit and the coefficient shows the value of the bit.

x^7 + x^6 + x^4 + x^3 + x + 1

1x^7 + 1x^6 + 0x^5 + 1 x^4 + 1x^3 + 0x^2 + 1x^1 + 1x^0

11011011

Step 1 :
at sender side, a string of n 0's is appended (ajouté) to the data unit
to be transmitted where n is one less than the number of bits in the CRC generator.


• suppose CRC generator = x^4 + x + 1 
then it equals = 1 x^4 + Ox^3 + 0x^2 + 1x^1 + 1x^0 = 10011
CRC = 10011

• suppose, data unit to be transmitted = 1101011011
after appending the n 0's (n is one less than the number of bits in the CRC generator)
we append 4 zeroes.
The data unit is 11010110110000 


Step 2: 
The newly formed data unit (=11010110110000) is divided by the divisor using binary division.
CRC (10011) / newly formed data unit (11010110110000)
see how we do the division.
The remainder is obtained. 
This remainder is called CRC. =(1110)
110000101


Step 3: 
String of n zero's appended to the data unit earlier is replaced by the CRC remainder (wich is also of n bit).
CRC remainder = 1110

Example : 
codeword after appending the 4 zeros = 11010110110000
CRC remainder = 1110

After replacing, 
Codeword = original data unit (1101011011) + CRC remainder (1110)
Codeword = 11010110111110

Step 4: 
original data unit (1101011011) + CRC remainder (1110) = codeword is transmitted to the receiver.


Step 5: 
The receiver on receiving the Codeword, divides (original data unit (1101011011) + CRC remainder (1110)) by the same divisor and checks the remainder. 


CRC (10011) /  Codeword (11010110111110) = remainder (0000)

step 6 : 
the receiver checks if the remainder is = 0.
if yes, receiver assumes that there is no error in data and therefore accepts it.
if no, there is an error in data and therefore rejects it.

CRC is an error detecting code from a computer to another.
the sending computer create the code and the receiving computer checks it. -->


</body>
</html>





